
default persistent.rep_visits = False
default persistent.RepSet = False
default persistent.mc_name_replay = "Garrett"
default replayPage = 1
default my_cols = 5

init python:
    import math
    replayItems = []
    replay_items_per_page = 15

    class ReplayItem:
        def __init__(self, label, image, lock_image, caption, scope=None, newtag=False):
            self.label = label
            self.image = image
            self.lock_image = lock_image
            self.caption = caption

            if scope is None: self.scope = {}
            else: self.scope = scope

            self.newtag = newtag

            self.unlocked = self.getUnlocked()

            replayItems.append(self)

        def getUnlocked(self):
            # return renpy.game.persistent._seen_ever[self.label]
            return renpy.seen_image(self.lock_image)

    def calculateRows( numPerRow, totalCount ):
        return int(math.ceil( totalCount / ( 1.0 * numPerRow ) ))


## Page 1
    ReplayItem("d1ChielAndGarrettSex1", "ShaddyMod/replayBtns/0110001.webp", "0110053", "", {})
    ReplayItem("d1ChielLindseyGarretSexScene", "ShaddyMod/replayBtns/0110054.webp", "0110126", "Lindsey Path", {})
    ReplayItem("d2QivianSexScene", "ShaddyMod/replayBtns/0210001.webp", "0210078", "Qivian Path", {})
    ReplayItem("d2ChielAndGarrettSex", "ShaddyMod/replayBtns/0210100.webp", "0210139", "", {})
    ReplayItem("d3SageThreesome", "ShaddyMod/replayBtns/0310001.webp", "0310054", "", {})
    ReplayItem("d4NaelaeSex", "ShaddyMod/replayBtns/0410001.webp", "0410062", "", {})
    ReplayItem("d4ChielSex", "ShaddyMod/replayBtns/0410100.webp", "0410137", "", {})
    ReplayItem("d5NovaSexScene", "ShaddyMod/replayBtns/0510001.webp", "0510058", "", {})
    ReplayItem("d7ChielMorningSex", "ShaddyMod/replayBtns/0710001.webp", "0710053", "", {})
    ReplayItem("d7AegisIntercourse", "ShaddyMod/replayBtns/0710100.webp", "0710164", "", {})
    ReplayItem("d8LindseySexScene", "ShaddyMod/replayBtns/0810001.webp", "0810060", "", {})
    ReplayItem("d9GoodMorningBabe", "ShaddyMod/replayBtns/0910001.webp", "0910040", "", {})
    ReplayItem("d9ZaenaSexScene", "ShaddyMod/replayBtns/0910101.webp", "0910147", "", {})
    ReplayItem("d10NadiasFirstTime", "ShaddyMod/replayBtns/1010001.webp", "1010074", "", {})
    ReplayItem("d11ShelxaeTime", "ShaddyMod/replayBtns/1110001.webp", "1110067", "", {})

## Page 2
    ReplayItem("d13AmoSex", "ShaddyMod/replayBtns/1310001.webp", "1310082", "", {})
    ReplayItem("d15ChielAndGarrett", "ShaddyMod/replayBtns/1510001.webp", "1510055", "", {})
    ReplayItem("d16SirenAndGarrett", "ShaddyMod/replayBtns/1610006.webp", "1610063", "", {})
    ReplayItem("d17NeesushAndGarrett", "ShaddyMod/replayBtns/1710001.webp", "1710062", "", {})
    ReplayItem("d17CarmellaAndGarrettSex", "ShaddyMod/replayBtns/1710100.webp", "1710163", "", {})
    ReplayItem("d18ThreesomeOne", "ShaddyMod/replayBtns/1810001.webp", "1810072", "", {})
    ReplayItem("d18ThreesomeTwo", "ShaddyMod/replayBtns/1810101.webp", "1810155", "", {})
    ReplayItem("d19ThressomeOne", "ShaddyMod/replayBtns/1910001.webp", "1910058", "", {})
    ReplayItem("d19TaraiaThreesome", "ShaddyMod/replayBtns/1910100.webp", "1910163", "", {})
    ReplayItem("d20NataliesFirstTime", "ShaddyMod/replayBtns/2010001.webp", "2010058", "", {})
    ReplayItem("d20QivianSceneVar1", "ShaddyMod/replayBtns/2010100.webp", "2010173", "Solo Qivian\nUpdate 20", {})
    ReplayItem("d20QivianSceneVar2", "ShaddyMod/replayBtns/2010200.webp", "2010345", "Matriarch threesome", {})
    ReplayItem("d21CarmellaSex", "ShaddyMod/replayBtns/2110001.webp", "2110072", "", {})
    ReplayItem("d21ZaenaBreeding", "ShaddyMod/replayBtns/2110100.webp", "2110166", "", {})
    ReplayItem("d22EdnaSex", "ShaddyMod/replayBtns/2210000.webp", "2210059", "", {})

## Page 3
    ReplayItem("d22SageEncounter1", "ShaddyMod/replayBtns/2210100.webp", "2210156", "", {})
    ReplayItem("d23MevaarThreesome", "ShaddyMod/replayBtns/2310001.webp", "2310100", "", {})
    ReplayItem("d23ChielSexScene", "ShaddyMod/replayBtns/2310300.webp", "2310362", "", {})
    ReplayItem("d25IyandaSexScene", "ShaddyMod/replayBtns/2510001.webp", "2510050", "", {})
    ReplayItem("d25ElaiOrgy", "ShaddyMod/replayBtns/2510100.webp", "2510200", "", {})
    ReplayItem("d26NicasFirstTime", "ShaddyMod/replayBtns/2610000.webp", "2610068", "", {})
    ReplayItem("d28SrahSexScene", "ShaddyMod/replayBtns/2810001.webp", "2810044", "", {})
    ReplayItem("d29NeesushSexScene", "ShaddyMod/replayBtns/2910001.webp", "2910050", "", {})
    ReplayItem("d29ChielSexScene", "ShaddyMod/replayBtns/2910101.webp", "2910151", "", {})
    ReplayItem("d30RhimusFirstTime", "ShaddyMod/replayBtns/3010001.webp", "3010056", "", {})
    ReplayItem("d30FoursomeScene", "ShaddyMod/replayBtns/3010101.webp", "3010223", "", {})
    ReplayItem("d31NadiaAndNatalieThreesome", "ShaddyMod/replayBtns/3110001.webp", "3110100", "", {})
    ReplayItem("d32EdeasEmbrace", "ShaddyMod/replayBtns/3210001.webp", "3210063", "", {})
    ReplayItem("d32SirenScene1", "ShaddyMod/replayBtns/3210100.webp", "3210189", "", {})
    ReplayItem("d33SirenSoloScene", "ShaddyMod/replayBtns/3310001.webp", "3310064", "", {})

## Page 4
    ReplayItem("d33TaraiaScene1", "ShaddyMod/replayBtns/3310101.webp", "3310148", "", {})
    ReplayItem("d34RizeiScene1", "ShaddyMod/replayBtns/3410001.webp", "3410047", "", {})
    ReplayItem("d34AnghaScene1", "ShaddyMod/replayBtns/3410100.webp", "3410150", "", {})
    ReplayItem("d35AndisScene1", "ShaddyMod/replayBtns/3510001.webp", "3510057", "", {})
    ReplayItem("d35RenaudScene1", "ShaddyMod/replayBtns/3510101.webp", "3510158", "", {})
    ReplayItem("d36ZilaScene1", "ShaddyMod/replayBtns/3610001.webp", "3610062", "", {})
    ReplayItem("d36ElizabethScene1", "ShaddyMod/replayBtns/3610101.webp", "3610156", "", {})
    ReplayItem("d37ChielSexScene", "ShaddyMod/replayBtns/3710001.webp", "3710058", "", {})
    ReplayItem("d38NicaScene", "ShaddyMod/replayBtns/3810001.webp", "3810052", "", {})
    ReplayItem("d38NaelaeScene", "ShaddyMod/replayBtns/3810101.webp", "3810166", "", {})
    ReplayItem("d40LindseySexScene", "ShaddyMod/replayBtns/4000073.webp", "4000120", "", {})
    ReplayItem("d40CarmellaSexScene", "ShaddyMod/replayBtns/4000191.webp", "4000248", "", {})
    ReplayItem("d40NeesushSexScene", "ShaddyMod/replayBtns/4000279.webp", "4000331", "", {})
    ReplayItem("d40TaraiaSexScene", "ShaddyMod/replayBtns/4000351.webp", "4000400", "", {})
    ReplayItem("d40SirenSexScene", "ShaddyMod/replayBtns/4000415.webp", "4000464", "", {})

## Page 5
    ReplayItem("d40SageSexScene", "ShaddyMod/replayBtns/4000481.webp", "4000533", "", {})
    ReplayItem("d40AnghaSexScene", "ShaddyMod/replayBtns/4000564.webp", "4000609", "", {})
    ReplayItem("d40RenaudSexScene", "ShaddyMod/replayBtns/4000629.webp", "4000678", "", {})
    ReplayItem("d40ZaenaSexScene", "ShaddyMod/replayBtns/4000703.webp", "4000739", "", {})
    ReplayItem("d40IyandaSexScene", "ShaddyMod/replayBtns/4000769.webp", "4000813", "", {})
    ReplayItem("d40NaelaeSexScene", "ShaddyMod/replayBtns/4000833.webp", "4000881", "", {})
    ReplayItem("d40NovaAegisSexScene", "ShaddyMod/replayBtns/4000894.webp", "4000964", "", {})
    ReplayItem("d40AndiSexScene", "ShaddyMod/replayBtns/4000983.webp", "4001034", "", {})
    ReplayItem("d40RizeSexScene", "ShaddyMod/replayBtns/4001060.webp", "4001103", "", {})
    ReplayItem("d40NadiaNatalieSexScene", "ShaddyMod/replayBtns/4001130.webp", "4001195", "", {})
    ReplayItem("d40NicaSexScene", "ShaddyMod/replayBtns/4001215.webp", "4001272", "", {})
    ReplayItem("d40QivianSexScene", "ShaddyMod/replayBtns/4001310.webp", "4001367", "", {})
    ReplayItem("d40SrahSexScene", "ShaddyMod/replayBtns/4001399.webp", "4001435", "", {})
    ReplayItem("d40ChielSexScene", "ShaddyMod/replayBtns/4001464.webp", "4001506", "", {})
    # ReplayItem("d40ChielSexScene", "ShaddyMod/replayBtns/4001464.webp", "4001506", "", {})


screen sceneReplay1():
    tag menu
    modal True

    $ ttl_items = len(replayItems)
    $ ttl_pages = calculateRows(replay_items_per_page, ttl_items)
    $ start_index = (replayPage -1) * replay_items_per_page
    $ end_index = start_index + replay_items_per_page
    $ page_items = replayItems[slice(start_index, end_index)]

    add "#000"
    add renpy.random.choice([
        "gui/main_menu.png","images/update1/0100013.webp","images/update1/0100053.webp",
        "images/update1/starfield.webp","images/update1/starfield2.webp","images/update1/starfield3.webp",
        "images/update1/starfield4.webp","images/update1/starfield5.webp","images/update1/starfield6.webp",
        "images/update1/starfield7.webp","images/update2/0200147.webp"
        ]) xcenter 0.5 ycenter 0.5 alpha 0.65

    vbox:
        xcenter 0.5
        ypos 20
        spacing 15
        hbox:
            xcenter 0.5
            # ycenter 40
            spacing 15
            hbox:
                spacing -5
                text "S" at delayed_blink(0.0, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "h" at delayed_blink(0.1, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "a" at delayed_blink(0.2, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "d" at delayed_blink(0.3, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "d" at delayed_blink(0.4, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "y" at delayed_blink(0.5, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "'" at delayed_blink(0.6, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "s" at delayed_blink(0.6, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
            hbox:
                spacing -5
                text "R" at delayed_blink(0.5, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "e" at delayed_blink(0.4, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "p" at delayed_blink(0.3, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "l" at delayed_blink(0.2, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "a" at delayed_blink(0.1, 2.0) outlines [(2, "#000")] style "ShaddyHeader"
                text "y" at delayed_blink(0.0, 2.0) outlines [(2, "#000")] style "ShaddyHeader"

        if ttl_pages > 1:
            hbox xcenter 0.5:
                spacing -5
                text "P" at delayed_blink(0.0, 2.0) outlines [(2, "#000")] style "ShaddyHeader" size 45
                text "a" at delayed_blink(0.1, 2.0) outlines [(2, "#000")] style "ShaddyHeader" size 45
                text "g" at delayed_blink(0.2, 2.0) outlines [(2, "#000")] style "ShaddyHeader" size 45
                text "e" at delayed_blink(0.1, 2.0) outlines [(2, "#000")] style "ShaddyHeader" size 45
                text " [replayPage]" at delayed_blink(0.0, 2.0) outlines [(2, "#000")] style "ShaddyHeader" size 45


    textbutton _("RENAME"):
        text_style "ShaddyTextButton1"
        align (0.01,1.0)
        action [ui.callsinnewcontext("renamemc")]

    hbox align(0.99,1.0) spacing -10:
        text "Replay codded by " style "ShaddyTextBody"
        textbutton "[smbl]ShaddyGames[smec]":
            ypos -7
            text_style "ShaddyTextButton2"
            action NullAction()
            # action Hide("ShaddySupport")
            hovered Show("ShaddySupport")

    # vpgrid rows 1 align(0.5, 0.9):
    hbox align(0.5, 0.9):
        textbutton "1" text_style "PageButtons" sensitive replayPage != 1 action SetVariable("replayPage", 1)
        textbutton "2" text_style "PageButtons" sensitive replayPage != 2 action SetVariable("replayPage", 2)
        textbutton "3" text_style "PageButtons" sensitive replayPage != 3 action SetVariable("replayPage", 3)
        textbutton "4" text_style "PageButtons" sensitive replayPage != 4 action SetVariable("replayPage", 4)
        textbutton "5" text_style "PageButtons" sensitive replayPage != 5 action SetVariable("replayPage", 5)

    textbutton "RETURN" align(0.5, 1.0) text_style "ShaddyTextButton1" action SetVariable("replayPage", 1), Hide("sceneReplay1"), Hide("ShaddySupport"), Return()

    $ ttr = GetTooltip()

    vpgrid:
        cols my_cols
        spacing 20
        align(0.5,0.5)

        for item in page_items:
            if item.getUnlocked():
                if not renpy.variant("mobile"):
                    $ scopeDict = {"quick_menu":False, "mc_name":persistent.mc_name_replay, "neesush_name":"Neesush", "nica_name":"Nica", "Zila_Daddy":"Daddy"}
                else:
                    $ scopeDict = {"mc_name":persistent.mc_name_replay, "neesush_name":"Neesush", "nica_name":"Nica", "Zila_Daddy":"Daddy"}
                $ scopeDict.update(item.scope)
                frame:
                    background Solid("#0ed6f97F")
                    xysize(250,145)
                    imagebutton:
                        xcenter 0.5 ycenter 0.5
                        idle Transform(item.image, zoom=0.6)
                        hover Transform(im.MatrixColor(item.image,im.matrix.brightness(0.20)), zoom=0.6)
                        action Replay(item.label, scope=scopeDict,locked=False)
                    if item.newtag:
                        hbox xcenter 0.5 ycenter 0.85 spacing -5:
                            text "N" at delayed_blink(0.1, 2.0) outlines [(2, "#000")] style "NewText"
                            text "E" at delayed_blink(0.2, 2.0) outlines [(2, "#000")] style "NewText"
                            text "W" at delayed_blink(0.3, 2.0) outlines [(2, "#000")] style "NewText"
            else:
                frame:
                    background Solid("#0ed6f97F")
                    xysize(250,145)
                    imagebutton:
                        xcenter 0.5 ycenter 0.5
                        idle Transform(im.Blur(item.image, 50.0), zoom=0.6)
                        tooltip item.label
                        action NullAction()
                    if item.newtag:
                        hbox xcenter 0.5 ycenter 0.15 spacing -5:
                            text "N" at delayed_blink(0.1, 2.0) outlines [(2, "#000")] style "NewText"
                            text "E" at delayed_blink(0.2, 2.0) outlines [(2, "#000")] style "NewText"
                            text "W" at delayed_blink(0.3, 2.0) outlines [(2, "#000")] style "NewText"
                    if ttr == item.label:
                        text "{}".format(item.caption) xcenter 0.5 ycenter 0.5 style "tt_textr"

screen ShaddySupport():
    button background None action Hide('ShaddySupport')
    frame background None align(0.9875,0.95):
        vbox spacing 5:
            imagebutton:
                idle im.Scale("ShaddyMod/images/patreon.png", 150, 40)
                hover im.Scale(im.MatrixColor("ShaddyMod/images/patreon.png", im.matrix.colorize("#cc33cc", "#009dff")), 150, 40)
                action OpenURL("https://www.patreon.com/ShaddyModda")
            imagebutton:
                idle im.Scale("ShaddyMod/images/substar.png", 150, 40)
                hover im.Scale(im.MatrixColor("ShaddyMod/images/substar.png", im.matrix.colorize("#cc33cc", "#009dff")), 150, 40)
                action OpenURL("https://subscribestar.adult/shaddymodda")
            imagebutton:
                idle im.Scale("ShaddyMod/images/Discord.png", 150, 40)
                hover im.Scale(im.MatrixColor("ShaddyMod/images/Discord.png", im.matrix.colorize("#f00", "#f00")), 150, 40)
                action OpenURL("https://discord.gg/MS3nkmkpm6")


label ReplayFirstLaunch:
    if not persistent.RepSet:
        scene black
        menu:
            "The main characters name in replay is [persistent.mc_name_replay], do you wish to change it?"
            "Yes":
                call renamemc from _call_renamemc_1
            "No":
                pass
        $ persistent.RepSet = True
    else:
        pass
    return

label Rep_end:
    scene black with dissolve
    $ renpy.end_replay()
    return


style ShaddyHeader is text:
    size 60
    outlines [(2,"#000",1,1)]
    color "#0ed6f9"

style ShaddyTextBody is text:
    size 25
    outlines [(2,"#000",1,1)]
    color "#0ed6f9"

style ShaddyTextButton1 is button_text:
    size 40
    idle_color "#0ed6f9"
    outlines [(2,"#000",1,1)]

style ShaddyTextButton2 is button_text:
    size 25
    idle_color "#3F60DE"
    hover_color "#0ed6f9"
    outlines [(2,"#000",1,1)]

style NewText is text:
    size 30
    color "#0ed6f9"
    outlines [(2,"#000",1,1)]

style tt_textr is text:
    size 30
    color "#0ed6f9"
    outlines [(2,"#000",1,1)]

style PageButtons is button_text:
    size 60
    idle_color "#0ed6f9"
    outlines [(2,"#000",1,1)]

style PageButtonDash is button_text:
    size 60
    idle_color "#0ed6f9"
    hover_color "#0ed6f9"
    outlines [(2,"#000",1,1)]


## 53 68 61 64 64 79 47 61 6D 65 73